OGRE: Ogre::SceneQuery Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::SceneQuery Class Reference
Core » Scene

A class for performing queries on a scene. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::SceneQuery:
[legend]

## Public Types
typedef Ogre::WorldFragment | WorldFragment

## Public Member Functions
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.

## Detailed Description

A class for performing queries on a scene.

This is an abstract class for performing a query on a scene, i.e. to retrieve a list of objects and/or world geometry sections which are potentially intersecting a given region. Note the use of the word 'potentially': the results of a scene query are generated based on bounding volumes, and as such are not correct at a triangle level; the user of the SceneQuery is expected to filter the results further if greater accuracy is required.

Different SceneManagers will implement these queries in different ways to exploit their particular scene organisation, and thus will provide their own concrete subclasses. In fact, these subclasses will be derived from subclasses of this class rather than directly because there will be region-type classes in between.

These queries could have just been implemented as methods on the SceneManager, however, they are wrapped up as objects to allow 'compilation' of queries if deemed appropriate by the implementation; i.e. each concrete subclass may precalculate information (such as fixed scene partitions involved in the query) to speed up the repeated use of the query.

You should never try to create a SceneQuery object yourself, they should be created using the SceneManager interfaces for the type of query required, e.g. SceneManager::createSphereQuery.

## Member Typedef Documentation

## ◆ WorldFragment

typedef Ogre::WorldFragment Ogre::SceneQuery::WorldFragment

## Constructor & Destructor Documentation

## ◆ SceneQuery()

Ogre::SceneQuery::SceneQuery | ( | SceneManager * | mgr | ) |

Standard constructor, should be called by SceneManager.

## ◆ ~SceneQuery()

virtual Ogre::SceneQuery::~SceneQuery | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ setQueryMask()

virtual void Ogre::SceneQuery::setQueryMask | ( | uint32 | mask | ) |
| virtual

Sets the mask for results of this query.

This method allows you to set a 'mask' to limit the results of this query to certain types of result. The actual meaning of this value is up to the application; basically MovableObject instances will only be returned from this query if a bitwise AND operation between this mask value and the MovableObject::getQueryFlags value is non-zero. The application will have to decide what each of the bits means.

## ◆ getQueryMask()

virtual uint32 Ogre::SceneQuery::getQueryMask | ( | void |  | ) | const
| virtual

Returns the current mask for this query.

## ◆ setQueryTypeMask()

virtual void Ogre::SceneQuery::setQueryTypeMask | ( | uint32 | mask | ) |
| virtual

Sets the type mask for results of this query.

This method allows you to set a 'type mask' to limit the results of this query to certain types of objects. Whilst setQueryMask deals with flags set per instance of object, this method deals with setting a mask on flags set per type of object. Both may exclude an object from query results.

## ◆ getQueryTypeMask()

virtual uint32 Ogre::SceneQuery::getQueryTypeMask | ( | void |  | ) | const
| virtual

Returns the current mask for this query.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h